<?php

/* --------------------------------------------------------------------

Author: 松鼠大大
Author URL: https://doge.uk/
Version: 1.1
Thanks: https://github.com/denpamusic/chevereto-yandex-oauth
@Chevereto: 3.18.1
@requires route.install-social.php

  --------------------------------------------------------------------- */

$route = function($handler) {
	// Must be an admin
	if(!CHV\Login::getUser()['is_admin'] || !CHV\Settings::get('chevereto_version_installed')) {
		G\redirect();
		return;
	}
	/* Get table prefix */
	$table_prefix = G\get_app_setting('db_table_prefix');
	$fields = G\DB::queryFetchAll("DESCRIBE ${table_prefix}logins");
	foreach($fields as $v) {
		if($v['Field'] == 'login_type') {
			$login_type = $v['Type'];
			continue;
		}
	}
	$login_type = explode(',', trim(str_replace('enum(', '(', $login_type), '()'));
	$login_type_new = ["'github'", "'cookie_github'", "'qq'", "'cookie_qq'", "'weibo'", "'cookie_weibo'", "'outlook'", "'cookie_outlook'"];

	$result = array_intersect($login_type, $login_type_new);
	$result = array_diff($login_type_new, $result);

	if ( empty($result) ) {
		$tips = 'You\'ve upgraded your database！<br>您已经升级过数据库了！<br><br>For security reasons, delete this upgrade file after the operation is completed.<br>为安全起见，在运行完成后删除此升级文件！！！<br><code style="color:#c7254e;padding: 2px 4px;background-color: #f9f2f4;border-radius: 4px;">\app\routes\overrides\route.install-social.php</code>';
		die($tips);
	}

	$login_type = array_unique(array_merge_recursive($login_type, $login_type_new));
	$login_type = implode(',', $login_type);
	$sql_update = [
		/* Settings values */
		//QQ
		'qq' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'qq', 0, 0, 'bool');",
		'qq_client_id' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'qq_client_id', NULL, NULL, 'string');",
		'qq_client_secret' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'qq_client_secret', NULL, NULL, 'string');",
		//Weibo
		'weibo' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'weibo', 0, 0, 'bool');",
		'weibo_client_id' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'weibo_client_id', NULL, NULL, 'string');",
		'weibo_client_secret' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'weibo_client_secret', NULL, NULL, 'string');",
		//Outlook
		'outlook' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'outlook', 0, 0, 'bool');",
		'outlook_client_id' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'outlook_client_id', NULL, NULL, 'string');",
		'outlook_client_secret' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'outlook_client_secret', NULL, NULL, 'string');",
		//GitHub
		'github' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github', 0, 0, 'bool');",
		'github_client_id' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github_client_id', NULL, NULL, 'string');",
		'github_client_secret' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github_client_secret', NULL, NULL, 'string');",						
		/* Support new social login type */
		"ALTER TABLE `${table_prefix}logins` CHANGE `login_type` `login_type` ENUM($login_type) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL;",
	];
	$settings = G\DB::queryFetchAll("SELECT `setting_name` FROM `${table_prefix}settings`");
	// Remove existing settings
	foreach($settings as $v) {
		if( isset($sql_update[$v['setting_name']]) ) {
			unset($sql_update[$v['setting_name']]);
		}
	}
	$sql_update = join("\r\n", $sql_update);
	try {
		$db = G\DB::getInstance();
		$db->query($sql_update);
		$updated = $db->exec();
		if($updated) {
			echo 'OK, Database upgrade completed.<br>好的，数据库升级完成。<br><br>For security reasons, delete this upgrade file after the operation is completed.<br>为安全起见，在运行完成后删除此升级文件！！！<br><code style="color:#c7254e;padding: 2px 4px;background-color: #f9f2f4;border-radius: 4px;">\app\routes\overrides\route.install-social.php</code>';
		}
		exit();
	} catch(Exception $e) {
		G\exception_to_error($e);
	}
};