<?php if (!defined('access') or !access) {
    die('This file cannot be directly accessed.');
} ?>
<?php
//引入Socialite库
use Overtrue\Socialite\SocialiteManager;
        switch ($doing) {
            case 'github':
                $config = [
                    'github' => [
                        'client_id' => CHV\getSetting('github_client_id'),
                        'client_secret' => CHV\getSetting('github_client_secret'),
                        'redirect' => G\get_base_url('connect/github'),
                    ],
                ];
                $error = false;
                $client = new SocialiteManager($config);

                if (isset($_GET['code'])) {
                    $redirCallback = false;
                    $get_code = $_GET['code'];
                    $get_user = $client->create('github')->userFromCode($get_code);
                    $access_token = $get_user->getAccessToken();
                    $redirCallback = false;
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $error = 'Github connect error: bad credentials or tokens';
                    } else {
                        $do_insert = true;
                        $do_cookie = true;
                    }
                } elseif ($logged_doing) {
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $redirCallback = true;
                        $error = 'Github connect error: bad credentials or tokens';
                    } else {
                        $redirCallback = false;
                        $do_cookie = true;
                    }
                }

                if ($redirCallback) {
                    $url = $client->create('github')->redirect();
                    G\redirect($url);
                }

                if ($error) {
                    unset($_SESSION['github']);
                    throw new Exception($error, 400);
                }

                $social_pictures = [
                    'avatar'        => $get_user->getAvatar(),
                    'background'    => null
                ];
                $connect_user = [
                    'id' => $get_user->getId(),
                    'username'    => G\sanitize_string(G\unaccent_string($get_user->getName()), true, true),
                    'name'        => trim($get_user->getName()),
                    'avatar'    => $get_user->getAvatar(),
                    'url'        => $get_user->getRaw()['html_url'],
                    'website'    => null,
                    'email'     => $get_user->getEmail()
                ];
                $connect_tokens = [
                    'secret'    => $get_user->getAccessToken(),
                    'token_hash' => null
                ];
                break;
            case 'qq':
                $config = [
                    'qq' => [
                        'client_id' => CHV\getSetting('qq_client_id'),
                        'client_secret' => CHV\getSetting('qq_client_secret'),
                        'redirect' => G\get_base_url('connect/qq'),
                    ],
                ];
                $error = false;
                $client = new SocialiteManager($config);

                if (isset($_GET['code'])) {
                    $redirCallback = false;
                    $get_code = $_GET['code'];
                    $get_user = $client->create('qq')->userFromCode($get_code);
                    $access_token = $get_user->getAccessToken();
                    $redirCallback = false;
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $error = 'QQ connect error: bad credentials or tokens';
                    } else {
                        $do_insert = true;
                        $do_cookie = true;
                    }
                } elseif ($logged_doing) {
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $redirCallback = true;
                        $error = 'QQ connect error: bad credentials or tokens';
                    } else {
                        $redirCallback = false;
                        $do_cookie = true;
                    }
                }

                if ($redirCallback) {
                    $url = $client->create('qq')->redirect();
                    G\redirect($url);
                }

                if ($error) {
                    unset($_SESSION['qq']);
                    throw new Exception($error, 400);
                }

                $social_pictures = [
                    'avatar'        => $get_user->getAvatar(),
                    'background'    => null
                ];
                $connect_user = [
                    'id' => $get_user->getId(),
                    'username'    => G\sanitize_string(G\unaccent_string($get_user->getName()), true, true),
                    'name'        => trim($get_user->getName()),
                    'avatar'    => $get_user->getAvatar(),
                    'url'        => null,
                    'website'    => null,
                ];
                $connect_tokens = [
                    'secret'    => $get_user->getAccessToken(),
                    'token_hash' => null
                ];
                break;
            case 'weibo':
                $config = [
                    'weibo' => [
                        'client_id' => CHV\getSetting('weibo_client_id'),
                        'client_secret' => CHV\getSetting('weibo_client_secret'),
                        'redirect' => G\get_base_url('connect/weibo'),
                    ],
                ];
                $error = false;
                $client = new SocialiteManager($config);

                if (isset($_GET['code'])) {
                    $redirCallback = false;
                    $get_code = $_GET['code'];
                    $get_user = $client->create('weibo')->userFromCode($get_code);
                    $access_token = $get_user->getAccessToken();
                    $redirCallback = false;
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $error = 'Weibo connect error: bad credentials or tokens';
                    } else {
                        $do_insert = true;
                        $do_cookie = true;
                    }
                } elseif ($logged_doing) {
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $redirCallback = true;
                        $error = 'Weibo connect error: bad credentials or tokens';
                    } else {
                        $redirCallback = false;
                        $do_cookie = true;
                    }
                }

                if ($redirCallback) {
                    $url = $client->create('weibo')->redirect();
                    G\redirect($url);
                }

                if ($error) {
                    unset($_SESSION['weibo']);
                    throw new Exception($error, 400);
                }

                $social_pictures = [
                    'avatar'        => $get_user->getAvatar(),
                    'background'    => null
                ];
                $connect_user = [
                    'id' => $get_user->getId(),
                    'username'    => G\sanitize_string(G\unaccent_string($get_user->getName()), true, true),
                    'name'        => trim($get_user->getName()),
                    'avatar'    => $get_user->getAvatar(),
                    'url'        => null,
                    'website'    => null,
                ];
                $connect_tokens = [
                    'secret'    => $get_user->getAccessToken(),
                    'token_hash' => null
                ];
                break; 
            case 'outlook':
                $config = [
                    'outlook' => [
                        'client_id' => CHV\getSetting('outlook_client_id'),
                        'client_secret' => CHV\getSetting('outlook_client_secret'),
                        'redirect' => G\get_base_url('connect/outlook'),
                    ],
                ];
                $error = false;
                $client = new SocialiteManager($config);

                if (isset($_GET['code'])) {
                    $redirCallback = false;
                    $get_code = $_GET['code'];
                    $get_user = $client->create('outlook')->userFromCode($get_code);
                    $access_token = $get_user->getAccessToken();
                    $redirCallback = false;
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $error = 'Outlook connect error: bad credentials or tokens';
                    } else {
                        $do_insert = true;
                        $do_cookie = true;
                    }
                } elseif ($logged_doing) {
                    $query = [
                        'user_id' => $get_user->getId(),
                        'fields' => ['photo_200', 'site', 'domain']
                    ];
                    if (!$get_user) {
                        $redirCallback = true;
                        $error = 'Outlook connect error: bad credentials or tokens';
                    } else {
                        $redirCallback = false;
                        $do_cookie = true;
                    }
                }

                if ($redirCallback) {
                    $url = $client->create('outlook')->redirect();
                    G\redirect($url);
                }

                if ($error) {
                    unset($_SESSION['outlook']);
                    throw new Exception($error, 400);
                }
                
                $social_pictures = [
                    'avatar'        => $get_user->getAvatar(),
                    'background'    => null
                ];
                $connect_user = [
                    'id' => $get_user->getId(),
                    'username'    => G\sanitize_string(G\unaccent_string($get_user->getName()), true, true),
                    'name'        => trim($get_user->getName()),
                    'avatar'    => $get_user->getAvatar(),
                    'url'        => null,
                    'website'    => null,
                    'email'     => $get_user->getEmail(),
                ];
                $connect_tokens = [
                    'secret'    => $get_user->getAccessToken(),
                    'token_hash' => null
                ];
                break;                
        }
